/*!
 * kuntai js class
 * @copyright   上海锟钛软件科技有限公司 2022
 * @license     MIT
 * @author      kuntai<kuntai@kuntaisoft.cn>
 * @link        http://www.kuntaisoft.cn
 * 
 */

function GetNewPeriodMonth(type,year,month)
{
	var currentDate;
	if("+1" === type){
		if(month=='12'){
			month = '01';
			year = ''+ ( parseInt(year) +1);
		}
		else{
			month = ''+ ( parseInt(month) +1)
			if(month.length== 1) month = '0' + month;
		}
		currentDate = 	year + month;
	}
	else if("-1" === type){
		if(month=='01'){
			month = '12';
			year =  ''+( parseInt(year) -1);
		}
		else{
			month = ''+ ( parseInt(month) -1);
			if(month.length== 1) month = '0' + month;
		}
		currentDate = 	year + month;
	}
	else{
		currentDate = 	year + month;
	}
	return currentDate;
}

//kendogrid 公共变量
var kuntai_kendogrid_div; //grid 变量表示$("#grid")
var kuntai_kendogrid; //grid 变量表示$("#grid").kendoGrid
var kuntai_kendogrid_columnsSets = '';//表格数据
var kuntai_kendogrid_DataArray = []; //global data array
var kuntai_kendogrid_fileName = '';//输出文件名的 公共变量
var kuntai_kendogrid_dataItem = '';//表格行内数据
var kuntai_kendogrid_toolbar = '';//toolbar

var kuntai_today = '';//today string

var kuntai_ModelWnd; //模态窗口
var kuntai_detailsTemplate;//详细模版

/**
 * 初始化参数
 * 2019-06-02
 */
function kuntai_base_initialParam() {
	kuntai_kendogrid_div = $("#grid"); //referrer to grid
	kuntai_today = kuntai_GetTodayStr(); // 具体日期。
	kuntai_kendogrid_fileName = 'Kendo_UI_Grid_Export_' + kuntai_today + '.xlsx';
}

//获得今天日期字符串
function kuntai_GetTodayStr() {
	 var date = new Date();
	 var month = date.getMonth() + 1;
	 var strDate = date.getDate();
	 if (month >= 1 && month <= 9) {
			 month = "0" + month;
		 }
	 if (strDate >= 0 && strDate <= 9) {
			strDate = "0" + strDate;
		 }
	 var currentDate = date.getFullYear() + '-' + month + '-' + strDate;
	 return currentDate;
}

/**
 * 定义kuntai_ERROR的类变量
 * 2019-05-07
 */
var kuntai_ERROR = {
	createNew: function () {
		var err = {};
		err.code = 0;
		err.msg = '';
		err.data = [];
		err.isError = function () {
			return 0 != err.code;
		};
		return err;
	}
};

/**
 * Check input object is kuntai_ERROR or not
 * 2019-05-07
 * @param kuntai_ERROR iData
 * @return kuntai_ERROR
 */
function kuntai_CheckJsonReturnData(iData) {
	var ret = kuntai_ERROR.createNew();
	ret.code = 1;

	if (iData === null || !(iData.constructor === Object)) {
		ret.msg = 'It is not an Object : ' + iData;
		return ret;
	}

	if (!(iData.hasOwnProperty("code"))) {
		ret.code = 20;
		ret.msg = 'Error! No code property in json!';
		return ret;
	}
	else if (iData.code > 0) {
		//获得code
		ret.code = iData.code;
		ret.msg = (iData.hasOwnProperty("msg")) ? iData.msg : 'Unkown Error!';
		return ret;
	}
	if (!(iData.hasOwnProperty("data"))) {
		ret.code = 22;
		ret.msg = 'Error! No Data property in json!';
		return ret;
	}
	//获得code
	ret.code = iData.code;
	if (iData.code > 0) {
		ret.msg = ((iData.hasOwnProperty("msg")) ? iData.msg : 'Unkown Error!');
	}
	return ret; //no error
}

 /**
 * 展示kendogrid数据
 * kuntai_kendogrid_DataArray = null表示全部显示列
 * 设定kuntai_kendogrid的引用
 * 2019-05-07
 */
function kuntai_kendogrid_updateGridData() {
	var record = 0;
	$("#grid").data("kendoGrid").destroy();
	$("#grid").html("");
	$("#grid").kendoGrid({
		columnMenu: true,
		columns: kuntai_kendogrid_columnsSets,
		dataSource: kuntai_kendogrid_DataArray,
		dataBinding: function () {
			kuntai_kendogrid = this;
			record = (this.dataSource.page() - 1) * this.dataSource.pageSize();
		},
		selectable: "row",
		filterable: true,
		groupable: true,
		sortable: true,
		pageable: {
			pageSize: 15,
			pageSizes: [10, 15, 20, 50, 100, 200, 500, 1000, 2000],
			messages: {
				display: "{0}-{1} 共{2}个",
				empty: "无数据",
				itemsPerPage: "项每页"
			}
		},
		resizable: true,
		toolbar: kuntai_kendogrid_toolbar,
		excel: {
			fileName: kuntai_kendogrid_fileName,
			allPages: true//是否导出所有页中的数据
		}
	});
}

//-----------------------------------
//-获得form的数据，form Post的参数模式.
//$(iName) : $("#form1")--------------------
//-----------------------------------
function kuntai_serializeArray(iName) {
	var d = {};
	var t = $(iName).serializeArray();
	$.each(t,function() {
		if(d.hasOwnProperty(this.name)){
			//说明是数组
			if(typeof d[this.name] != 'object'){
				oldvalue = d[this.name];
				d[this.name]=[];
				d[this.name].push(oldvalue);
			}

			d[this.name].push(this.value);
		} else {
			d[this.name] = this.value;
		}
	});
	return d;
}